SystemOrganization addCategory: #'Seaside-Pharo-Core-Document'!

WAEncoder subclass: #WAPharoEncoder
	instanceVariableNames: 'table delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Core-Document'!

WAPharoEncoder class
	instanceVariableNames: 'table'!

WAPharoEncoder class
	instanceVariableNames: 'table'!

!WAPharoEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:50'!
delegateOn: aStream
	self subclassResponsibility! !

!WAPharoEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/14/2011 17:52'!
on: aStream
	^ self basicNew
		initializeOn: aStream
		table: table
		delegate: (self delegateOn: aStream)! !

!WAPharoEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	self subclassResponsibility! !

!WAPharoEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 8/14/2011 22:45'!
greaseNext: anInteger putAll: aCollection startingAt: startIndex
	aCollection isByteString
		ifTrue: [ self greaseNext: anInteger putAllFast: aCollection startingAt: startIndex ]
		ifFalse: [ delegate greaseNext: anInteger putAll: aCollection startingAt: startIndex ]! !

!WAPharoEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 4/21/2012 20:23'!
greaseNext: anInteger putAllFast: aByteString startingAt: startIndex
	| lastIndex nextIndex |
	lastIndex := startIndex.
	nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
	(nextIndex = 0 or: [ nextIndex = (startIndex + anInteger) ]) ifTrue: [
		^ stream greaseNext: anInteger putAll: aByteString startingAt: startIndex ].
	[	
		nextIndex >= (startIndex + anInteger) ifTrue: [
			^ stream greaseNext: startIndex + anInteger - nextIndex + 1 putAll: aByteString startingAt: lastIndex ].
		nextIndex > lastIndex ifTrue: [
			stream greaseNext: nextIndex - lastIndex putAll: aByteString startingAt: lastIndex ].
		"let the delegate do the actual encoding"
		delegate nextPut: (aByteString at: nextIndex).
		lastIndex := nextIndex + 1.
		nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
		(nextIndex = 0 or: [ nextIndex >= (startIndex + anInteger) ]) ] whileFalse.
	lastIndex >= (startIndex + anInteger) ifFalse: [
		stream greaseNext: startIndex + anInteger - lastIndex putAll: aByteString startingAt: lastIndex ]! !

!WAPharoEncoder methodsFor: 'private' stamp: 'pmm 8/14/2011 21:58'!
includesUnsafeCharacter: aString
	^ (ByteString findFirstInString: aString inSet: table startingAt: 1) ~= 0! !

!WAPharoEncoder methodsFor: 'initialization' stamp: 'pmm 8/14/2011 13:34'!
initializeOn: aStream table: anArray delegate: anEncoder
	self initializeOn: aStream.
	table := anArray.
	delegate := anEncoder.! !

!WAPharoEncoder methodsFor: 'accessing' stamp: 'pmm 8/14/2011 22:07'!
nextPut: aCharacter
	"Don't bother, directly go the the look up table"
	delegate nextPut: aCharacter! !

!WAPharoEncoder methodsFor: 'accessing' stamp: 'pmm 8/14/2011 21:59'!
nextPutAll: aString
	aString isByteString
		ifTrue: [ self nextPutAllFast: aString ]
		ifFalse: [
			"slow fall back for WideStrings"
			delegate nextPutAll: aString ]! !

!WAPharoEncoder methodsFor: 'private' stamp: 'pmm 8/14/2011 22:02'!
nextPutAllFast: aByteString
	| lastIndex nextIndex |
	lastIndex := 1.
	nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
	nextIndex = 0 ifTrue: [ ^ stream nextPutAll: aByteString ].
	[	nextIndex > lastIndex ifTrue: [
			stream greaseNext: nextIndex - lastIndex putAll: aByteString startingAt: lastIndex ].
		"let the delegate do the actual encoding"
		delegate nextPut: (aByteString at: nextIndex).
		lastIndex := nextIndex + 1.
		nextIndex := ByteString findFirstInString: aByteString inSet: table startingAt: lastIndex.
		nextIndex = 0 ] whileFalse.
	stream greaseNext: aByteString size - lastIndex + 1 putAll: aByteString startingAt: lastIndex.! !

WAPharoEncoder subclass: #WAPharoUrlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Core-Document'!

!WAPharoUrlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:51'!
delegateOn: aStream
	^ WAUrlEncoder on: aStream! !

!WAPharoUrlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 13:26'!
initialize
	self initializeUrlTable! !

!WAPharoUrlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:49'!
initializeUrlTable
	table := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: (Character codePoint: index - 1))
			ifTrue: [ table at: index put: 0 ]
			ifFalse: [ table at: index put: 1 ] ]! !

!WAPharoUrlEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	^ aCodec url encoderFor: (self on: aStream)! !

!WAPharoUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 8/14/2011 13:39'!
basicNextPut: aCharacter
	self nextPut: aCharacter! !

!WAPharoUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 8/14/2011 13:40'!
indexOfFirstUnsafeUrlCharacterIn: aString startingAt: startIndex
	^ aString isWideString "use slow fallback for WideStrings"
		ifTrue: [ startIndex ]
		ifFalse: [ ByteString findFirstInString: aString inSet: table startingAt: startIndex ]! !

!WAPharoUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 8/14/2011 13:39'!
isBinary
	^ false! !

WAPharoEncoder subclass: #WAPharoXmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Core-Document'!

!WAPharoXmlEncoder class methodsFor: 'private' stamp: 'pmm 8/14/2011 17:51'!
delegateOn: aStream
	^ WAXmlEncoder on: aStream! !

!WAPharoXmlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 13:25'!
initialize
	self initializeXmlTable! !

!WAPharoXmlEncoder class methodsFor: 'class initialization' stamp: 'pmm 8/14/2011 17:50'!
initializeXmlTable
	table := ByteArray new: 256.
	1 to: 256 do: [ :index |
		('"<&>' includes: (Character codePoint: index - 1))
			ifTrue: [ table at: index put: 1 ]
			ifFalse: [ table at: index put: 0 ] ]! !

!WAPharoXmlEncoder class methodsFor: 'instance creation' stamp: 'pmm 8/15/2011 08:23'!
on: aStream codec: aCodec
	^ self on: aStream! !

!BlockClosure methodsFor: '*seaside-pharo-core' stamp: 'lr 4/8/2009 13:32'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Dictionary methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/31/2010 08:19'!
snapshotCopy
	^ self copy! !

!GRPackage class methodsFor: '*seaside-pharo-core' stamp: 'lr 2/17/2010 15:12'!
seasidePharoCore
	^ self new
		name: 'Seaside-Pharo-Core';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Pharo-Core';
		url: #seasideUrl;
		yourself! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'jf 9/22/2008 13:21'!
defaultMimeType
	^ WAMimeType imageGif! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'mb 6/12/2006 14:01'!
mimeType
	^ self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 16:39'!
seasideMimeDocument
	^ self seasideMimeDocumentType: self defaultMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	"Converts the receiver to a WAMimeDocument. The argument should ideally be an instance for WAMimeType. For various crappy reasons Strings and nil are also allowed."
	
	| aStream writer |
	aStream := RWBinaryOrTextStream on: String new.
	writer := self writerForMimeType: aMimeType seasideMimeType.
	writer isNil ifTrue: [ self error: 'no writer for ', aMimeType greaseString, ' found' ].
	writer putForm: (self asFormOfDepth: 32) onStream: aStream.
	^ WAMimeDocument on: aStream contents mimeType: aMimeType! !

!Form methodsFor: '*seaside-pharo-core' stamp: 'pmm 4/2/2012 19:16'!
writerForMimeType: mimeType
	| sub |
	mimeType main ~= 'image'
		ifTrue: [ ^ nil ]. 
	"First token is assumed to be 'image'"
	sub := mimeType sub.
	(sub = 'jpg' or: [ sub = 'jpeg' ]) ifTrue: [
		"try PluginBasedJPEGReadWriter, JPEGReadWriter2 and JPEGReadWriter"
		^ Smalltalk
			at: #PluginBasedJPEGReadWriter
			ifAbsent: [
				Smalltalk
					at: #JPEGReadWriter2
					ifAbsent: [
						Smalltalk
							at: #JPEGReadWriter
							ifAbsent: [ nil ] ] ] ].
	sub = 'png' ifTrue: [ ^ PNGReadWriter ].
	sub = 'bmp' ifTrue: [ ^ BMPReadWriter ].
	sub = 'gif' ifTrue: [ ^ GIFReadWriter ].
	^ nil! !

!SmalltalkImage methodsFor: '*seaside-pharo-core' stamp: 'pmm 1/24/2011 07:20'!
initializeMemorySettingsProfileSeaside
        "Initialize the memory and GC settings to be more in line with Seaside requirements"
        
        "The following settings affect the rate incremental GCs and tenuring"
        
        "Limit incremental GC activity to run every 40k allocations"
        self vmParameterAt: 5 put: 100000. "allocations between GCs (default: 4000)"
        "Limit tenuring threshold to only tenure w/ > 35k survivors"
        self vmParameterAt: 6 put: 35000. "tenuring threshold (default: 2000)"
        
        "These settings affect overall memory usage"
        
        "Only give memory back to the OS when we have more than 16MB free"
        self vmParameterAt: 24 put: 16*1024*1024. "default 8MB"
        "Try to keep 8MB headroom at all times"
        self vmParameterAt: 25 put: 8*1024*1024. "default 4MB"
        
        "These settings describe what to do when we're close to running out of free space"
        
        "Tell the VM that we'd rather grow than spinning in tight GC loops"
        self setGCBiasToGrow: 1. "default: false"
        "Tell the VM to do a fullGC for good measure if the above growth exceeded 16MB"
        self setGCBiasToGrowGCLimit: 16*1024*1024. "default: 0"! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 11/16/2007 17:11'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!OrderedCollection methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
snapshotCopy
	^ self copy! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:53'!
seasideMimeDocument
	^ self contents seasideMimeDocument! !

!PositionableStream methodsFor: '*seaside-pharo-core' stamp: 'lr 7/25/2011 19:52'!
seasideMimeDocumentType: aMimetype
	^ self seasideMimeDocument
		mimeType: aMimetype;
		yourself! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:50'!
seasideMimeDocument
	^ self imageForm seasideMimeDocument! !

!Morph methodsFor: '*seaside-pharo-core' stamp: 'pmm 6/19/2010 08:30'!
seasideMimeDocumentType: aMimeType
	^ self imageForm seasideMimeDocumentType: aMimeType! !

!BlockContext methodsFor: '*seaside-pharo-core' stamp: 'lr 4/19/2009 13:30'!
renderOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!GRPharoPlatform methodsFor: '*seaside-pharo-core' stamp: 'pmm 8/14/2011 17:55'!
urlEncoderOn: aStream
	^ WAPharoUrlEncoder on: aStream! !

!GRPharoPlatform methodsFor: '*seaside-pharo-core' stamp: 'pmm 8/14/2011 21:43'!
urlEncoderOn: aStream codec: aCodec
	^ aCodec url encoderFor: (WAPharoUrlEncoder on: aStream)! !

!GRPharoPlatform methodsFor: '*seaside-pharo-core' stamp: 'pmm 8/14/2011 17:57'!
xmlEncoderOn: aStream
	^ WAPharoXmlEncoder on: aStream! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Bag methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 4/20/2007 20:43'!
snapshotCopy
	^ self copy! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'lr 10/18/2008 15:54'!
seasideMimeDocument
	^ WAMimeDocument on: self content mimeType: self contentType! !

!MIMEDocument methodsFor: '*seaside-pharo-core' stamp: 'lr 7/25/2011 19:52'!
seasideMimeDocumentType: aMimeType
	^ self seasideMimeDocument mimeType: aMimeType; yourself! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 1/3/2008 18:25'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Set methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 6/7/2007 22:14'!
snapshotCopy
	^ self copy! !

!MessageSend methodsFor: '*seaside-pharo-core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/19/2007 23:13'!
restoreFromSnapshot: anObject
	self copyFrom: anObject! !

!Object methodsFor: '*seaside-pharo-core-backtracking' stamp: 'lr 3/15/2008 18:45'!
snapshotCopy
	^ self shallowCopy! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:16'!
basicNextPut: aCharacter
	self nextPut: aCharacter! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'rh 11/9/2011 15:20'!
basicNextPutAll: anObject
	self nextPutAll: anObject! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:40'!
greaseNext: anInteger putAll: aCollection startingAt: startIndex
	| index |
	index := GRPlatform current indexOfFirstUnsafeUrlCharacterIn: aCollection startingAt: startIndex.
	(index = 0 or: [ index >= (startIndex + anInteger) ])
		ifTrue: [
			stream greaseNext: anInteger putAll: aCollection startingAt: startIndex ]
		ifFalse: [ self nextPutAll: (aCollection copyFrom: startIndex to: startIndex + anInteger - 1) ]! !

!WAUrlEncoder methodsFor: '*seaside-pharo-core-document' stamp: 'pmm 12/27/2010 12:15'!
isBinary
	^ false! !
WAPharoUrlEncoder initialize!
WAPharoXmlEncoder initialize!
